# coding: utf-8

"""
    Gitea API

    This documentation describes the Gitea API.

    The version of the OpenAPI document: 1.22.4
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from py_gitea_opensuse_org.models.issue_form_field import IssueFormField
from typing import Optional, Set
from typing_extensions import Self

class IssueTemplate(BaseModel):
    """
    IssueTemplate represents an issue template for a repository
    """ # noqa: E501
    about: Optional[StrictStr] = None
    body: Optional[List[IssueFormField]] = None
    content: Optional[StrictStr] = None
    file_name: Optional[StrictStr] = None
    labels: Optional[List[StrictStr]] = None
    name: Optional[StrictStr] = None
    ref: Optional[StrictStr] = None
    title: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["about", "body", "content", "file_name", "labels", "name", "ref", "title"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of IssueTemplate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in body (list)
        _items = []
        if self.body:
            for _item_body in self.body:
                if _item_body:
                    _items.append(_item_body.to_dict())
            _dict['body'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of IssueTemplate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "about": obj.get("about"),
            "body": [IssueFormField.from_dict(_item) for _item in obj["body"]] if obj.get("body") is not None else None,
            "content": obj.get("content"),
            "file_name": obj.get("file_name"),
            "labels": obj.get("labels"),
            "name": obj.get("name"),
            "ref": obj.get("ref"),
            "title": obj.get("title")
        })
        return _obj


